﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;


namespace DataGrid
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            #region DataSource
            DataCollection dataSource = new DataCollection();
            Random rand = new Random();
            int r = rand.Next(100);
            for (int i = 1; i <= 50; i++)
            {
                dataSource.Add(new Data(r.ToString(), "Category" + r.ToString(), i.ToString(), r.ToString() + "Data"));
                r = rand.Next(100);
            }
            this.gridGroupingControl1.DataSource = dataSource;
            #endregion

            this.gridGroupingControl1.TableModel.CellModels.Add("CustomComboBox", new GridComboBoxCellModelAdv(this.gridGroupingControl1.TableModel));
            
            this.gridGroupingControl1.TableDescriptor.Columns["Description"].Appearance.AnyRecordFieldCell.CellType = "CustomComboBox";
            this.gridGroupingControl1.TableDescriptor.Columns["Description"].Appearance.AnyRecordFieldCell.DataSource = GetTable();
            this.gridGroupingControl1.TableDescriptor.Columns["Description"].Appearance.AnyRecordFieldCell.DisplayMember = "Value";
            this.gridGroupingControl1.TableDescriptor.Columns["Description"].Appearance.AnyRecordFieldCell.ValueMember = "ID";
            this.gridGroupingControl1.TableDescriptor.Columns["Description"].Appearance.AnyRecordFieldCell.Format = "dd/MM/yy";
        }

        DataTable GetTable()
        {
            DataTable table = new DataTable();
            table.Columns.Add("ID", typeof(int));
            table.Columns.Add("Value", typeof(DateTime));
            for (int i = 1; i <= 50; i++)
            {
                DataRow row = table.NewRow();
                row["ID"] = i;
                row["Value"] = DateTime.Now.AddDays(i);
                table.Rows.Add(row);
            }
            return table;
        }
    }
    #region CustomComboBox
    public class GridComboBoxCellModelAdv : GridComboBoxCellModel
    {
        public GridComboBoxCellModelAdv(GridModel grid)
            : base(grid)
        {
            AllowFloating = false;
            ButtonBarSize = new Size(SystemInformation.VerticalScrollBarWidth, 0);
            SupportsChoiceList = true;
        }

        public override GridCellRendererBase CreateRenderer(GridControlBase control)
        {
            return new GridComboBoxCellRendererAdv(control, this);
        }

        public override string GetFormattedText(GridStyleInfo style, object value, int textInfo)
        {
            if (style.Format != string.Empty)
            {
                DateTime date = new DateTime();
                if (DateTime.TryParse(base.GetFormattedText(style, value, textInfo), out date))
                {
                    value = date.ToString(style.Format);
                }
                else if (style.CellValueType == typeof(string))
                {
                    value = string.Format("{0:" + style.Format + "}", base.GetFormattedText(style, value, textInfo));
                }
            }

            return base.GetFormattedText(style, value, textInfo);
        }
    }
    public class GridComboBoxCellRendererAdv : GridComboBoxCellRenderer
    {
        public GridComboBoxCellRendererAdv(GridControlBase grid, GridCellModelBase cellModel)
            : base(grid, cellModel)
        {
            DropDownImp.InitFocusEditPart = true;
            DropDownButton = new GridCellComboBoxButton(this);
        }

        protected override void OnSetControlText(string text)
        {
            if (StyleInfo.Format != string.Empty)
            {
                DateTime date = new DateTime();
                if (DateTime.TryParse(text, out date))
                {
                    text = date.ToString(StyleInfo.Format);
                }
                else if (StyleInfo.CellValueType == typeof(string))
                {
                    text = string.Format("{0:" + StyleInfo.Format + "}", text);
                }
            }
            base.OnSetControlText(text);
        }
    }
    #endregion

}
